package inf101.v18.rogue101.shared;

import inf101.v18.grid.GridDirection;
import inf101.v18.grid.ILocation;
import inf101.v18.rogue101.game.IGame;
import inf101.v18.rogue101.objects.IActor;

import java.util.List;

public class NPC {

    /**
     * Makes a NPC attack anything it can, or move closer to any enemy in its line of sight.
     *
     * @param game  An IGame object
     * @return      True if the NPC made a move. False otherwise
     */
    public static boolean tryAttack(IGame game) {
        List<ILocation> neighbours = game.getVisible();
        for (ILocation neighbour : neighbours) {
            if (game.getMap().hasActors(neighbour)) {
                ILocation current = game.getLocation();
                GridDirection dir = game.locationDirection(current, neighbour);
                IActor actor = game.getMap().getActors(neighbour).get(0); //We assume there is only one actor.
                if (current.gridDistanceTo(neighbour) <= 1 && current.canGo(dir) && game.getMap().has(current.go(dir), actor) && !actor.isDestroyed()) {
                    game.attack(dir, actor);
                    return true;
                } else if (game.canGo(dir)) {
                    game.move(dir);
                    return true;
                }
            }
        }
        return false;
    }
}
